/*  ENHC0019414  
    This should be run on system context so that taxonomy admin can see all taxonomy records and intiatives and update them
*/
public class PREPTaxonomyController{

    public List<PREPWrapper> prepWrapperList = new List<PREPWrapper>();
    public List<PREPInitiativeWrapper> prepInitiativeWrapperList = new List<PREPInitiativeWrapper>();
    public List<PREPprjInitiativeWrapper> prepprjInitiativeWrapperList = new List<PREPprjInitiativeWrapper>();
    public List<PREPTaxonomyWrapper> prepTaxonomyWrapperList = new List<PREPTaxonomyWrapper>();
    public PREPWrapper prepWrapper {get; set;}
    public String RequestTitle {get;set;}
    public boolean CategoryManager {get;set;}
    public boolean ctrcategoryManager {get;set;}
    public Boolean ownerFlag {get;set;}
    public Boolean ownerFlag1 {get;set;}
    public boolean prjOwner {get;set;}
    public boolean inOwner {get;set;}
    public boolean cinOwner {get;set;}
    public boolean SCMManager {get;set;}
    public boolean scmManager1 {get;set;}
    public boolean ctrscmManager {get;set;}
    public boolean categorySpecialist {get;set;}
    public boolean ctrcategorySpecialist {get;set;}
    public boolean CategoryTechnician {get;set;}
    public boolean ctrCategoryTechnician {get;set;}
    public boolean BusinessAnalyst {get;set;}
    public boolean prjBusinessAnalyst {get;set;}
    public boolean ctrBusinessAnalyst {get;set;} 
     public boolean GSO {get;set;}
     public boolean ctrGSO {get;set;}
     public boolean ProcurementRepresentative {get;set;}
     public boolean ctrProcurementRepresentative {get;set;}
     public boolean CommercialRepresentative {get;set;}
     public boolean ctrCommercialRepresentative {get;set;}
     public boolean ProjectLead {get;set;}
     public boolean ctrProjectLead {get;set;}
     public boolean t_Owner {get;set;}
     public boolean t_taxOwner {get;set;}
    public boolean t_categoryManager {get;set;}
    public boolean t_taxcategoryManager {get;set;}
    public boolean t_categorySpecialist {get;set;} 
    public boolean t_taxcategorySpecialist {get;set;}
    public PREP_Initiative__c user {get;set;}   
    public PREP_Material_Service_Group__c taxonomy {get;set;} 
    public boolean flag = false; 

    
    public List<PREP_Initiative__c> initiatives {get;set;}
     public List<PREP_Initiative__c> prjinitiatives {get;set;}
    public String[] selectedUserType = new String[]{};
    
    public List<PREP_Initiative__c> initiativeList {get; set;}
     public List<PREP_Initiative__c> prjinitiativeList {get; set;}
     public List<Contact> contactlist {get; set;}
    
    public PREPTaxonomyController(){
        initiativeList = new List<PREP_Initiative__c>();
        contactlist = new List<Contact>();
        prjinitiativeList = new List<PREP_Initiative__c>();
        
        user = new PREP_Initiative__c();
        taxonomy = new PREP_Material_Service_Group__c();
    }
    
    public List<SelectOption> getRequestTypes() {
        List<SelectOption> options = new List<SelectOption>();
        options.add( new SelectOption( 'None','--None--'));
        options.add( new SelectOption( 'PREP_Change_Ownership','Change Ownership'));
        options.add( new SelectOption( 'PREP_Change_Category','Change Category/Sub Category/Discipline'));
        options.add( new SelectOption( 'PREP_Change_Material_Service_Name','Change Long/Short Name' ));
        options.add( new SelectOption( 'PREP_Change_GL_Account_Code','Change GL Account Code' ));
        options.add( new SelectOption( 'PREP_Create_Taxonomy','Create New Material/Service Group' ));
        options.add( new SelectOption( 'PREP_Change_Includes','Change Includes/Does not Includes' ));
        options.add( new SelectOption( 'PREP_Retired_Taxonomy','Retire Material/Service Group' ));
        //options.add( new SelectOption( 'PREP_Change_Discipline','Change Discipline'));
        return options;
    }
    
    public void inoselectItem()    {  inOwner = true;}
    public void ctrprselectItem()  {  ctrProcurementRepresentative = true; }
    public void ctrcrselectItem()  {  ctrCommercialRepresentative = true;  }
    public void ctrcmselectItem()  {  ctrcategoryManager = true;      }
    public void ctrcpselectItem()  {  ctrcategorySpecialist = true;   }
    public void ctrbaselectItem()  {  ctrBusinessAnalyst = true;      }
    public void ctrselectItem()    {  ctrSCMManager = true;   } 
    public void ctrplselectItem()  {  ctrProjectLead = true;  } 
    public void ctrctselectItem()  {  ctrCategoryTechnician = true; }
    public void ctrgsselectItem()  {  ctrGSO = true; }
    public void taxcmSelectItem()   {  t_categoryManager= true;  }
    public void selectItem()       {  SCMManager = true;   }
    public void cpselectItem()     {  categorySpecialist = true;   }
    public void cmselectItem()     {  CategoryManager =true;    }
    public void baselectItem()     {   BusinessAnalyst = true;   }
    public void prjbaselectItem()   {   prjBusinessAnalyst = true;   }    
    public void gsselectItem()     {    GSO = true;  }
    public void prselectItem()     {   ProcurementRepresentative=true; }
    public void crselectItem()     {    CommercialRepresentative =true;  }
    public void ctselectItem()     {    CategoryTechnician = true;   }
    public void plselectItem()     {  ProjectLead = true; }
    public void oselectItem()      {   CategorySpecialist = true;  }
    public void piOwner()            {  ownerFlag = true;  }
     public void ciOwner()            {  cinOwner = true;  }
     public void prjselectItem()  { scmManager1 = true; }
    
    public void taxcsSelectItem()   {  t_categorySpecialist =true; }
    public void taxowner()          {  t_Owner =true; }

    public List<SelectOption> getUserTypes(){
        List<SelectOption> types = new List<SelectOption>();
        types.add(new SelectOption('CS','Category Specialist'));
        types.add(new SelectOption('CM','Category Manager'));
        types.add(new SelectOption('SCM','SCM Manager'));
        
        return types;
    }
    
    public List<PREPWrapper> getPrepWrapperList(){
        return prepWrapperList;
    }
    
    public List<PREPInitiativeWrapper> getPrepInitiativeList(){
        return prepWrapper.initWrapperList;
    }
     public List<PREPprjInitiativeWrapper> getPrepprjInitiativeList(){
        return prepWrapper.prjinitWrapperList;
    }  
    
    public List<PREPTaxonomyWrapper> getPrepTaxonomyList(){
        return prepWrapper.taxonomyWrapperList;
    } 
    
    public List<PREP_Change_Header__c> getSavedRequestHeaderList(){
        //get the list of saved changes 
        List<PREP_Change_Header__c> headerList = [SELECT Id, Name, CreatedDate, CreatedById, Approval_Status__c, Change_Status__c, Reason__c, Object_Name__c,Request_Created_Date__c, Change_Type__c, Request_Last_Updated_Date__c, Request_Status__c, Request_Title__c 
            FROM PREP_Change_Header__c WHERE Change_Status__c = 'New' ORDER BY Name];
            integer i=42;
        
        return headerList;
    }
    
    public List<PREP_Change_Header__c> getCompletedRequestHeaderList(){
        //get the list of saved changes 
        List<PREP_Change_Header__c> headerList = [SELECT Id, Name,Request_Status__c, CreatedDate, CreatedById,Request_Title__c , Approval_Status__c, Request_Created_Date__c, Change_Status__c, Reason__c, Object_Name__c,Request_Last_Updated_Date__c , Change_Type__c 
            FROM PREP_Change_Header__c WHERE Change_Status__c = 'Rejected' OR Change_Status__c = 'Cancelled' OR Change_Status__c = 'Completed' ORDER BY Name];
        
        return headerList;
    } 
    
    public List<PREP_Change_Header__c> getInprogressRequestHeaderList(){
        //get the list of saved changes 
        List<PREP_Change_Header__c> headerList = [SELECT Id, Name, CreatedDate, CreatedById, Approval_Status__c,Request_Status__c , Change_Status__c, Reason__c, Object_Name__c,Request_Last_Updated_Date__c , Request_Created_Date__c, Change_Type__c,Request_Title__c  
            FROM PREP_Change_Header__c WHERE Change_Status__c = 'Submitted' ORDER BY Name];
        
        return headerList;
    }     
    
    public List<PREP_Change_Header__c> getActionableRequestHeaderList(){
        //get the list of saved changes 
        List<PREP_Change_Header__c> headerList = [SELECT Id, Name, CreatedDate, CreatedById, Approval_Status__c,Request_Created_Date__c,Request_Title__c ,Request_Last_Updated_Date__c, Change_Status__c, Reason__c, Object_Name__c, Change_Type__c,Request_Status__c  
            FROM PREP_Change_Header__c WHERE Change_Status__c = 'Approved' ORDER BY Name];
        
        return headerList;
    }          
    
    public void displayTaxonomyAndInitiatives(){
    
        flag = false;
           System.debug('aaa'+categorySpecialist );
         prepWrapper = new PREPWrapper();
          
         string  CateInitiative = System.Label.Category_Initiative_RecId;
        string  ProInitiative = System.Label.Projects_Initiative_RecId;
        //get a list of PREP Initiatives and wrap it
       String  soql='SELECT Id,RecordTypeId,Name,Owner.Name,Initiative_Name__c ,Discipline__r.Name ,Tech_Services__r.Name, PMO__r.Name,Safety__r.Name,Category_Manager__r.Name,Status__c , Project_Lead__R.Name,Technician__r.Name,Commercial_Representative__r.Name,Procurement_Representative__r.Name,Category_Specialist__r.Name,SCM_Manager__r.Name,GSO__r.Name,Business_Analyst__r.Name FROM PREP_Initiative__c where RecordTypeId= \''+ CateInitiative +'\'';
        Contact con;
        
        if( user.category_Manager__c != null )
        {
            User u = [ Select Id, Email from User where Id = :user.category_Manager__c ];
            if( u != null && u.Email != null && u.Email != '' )
            {
                List<Contact> contacts = [ Select Id, Name from Contact where Email =: u.Email ];
                
                if( contacts.size() > 0 )
                    con = contacts[0];
            }
        }
        if( user.category_Manager__c != null )
        {
           if(inOwner)
           {
              soql+= ' AND OwnerId =\''+user.category_Manager__c +'\'';
              flag = true;
           }
            if(ctrSCMManager  )
           {
            soql+= ' AND SCM_Manager__c =\''+user.category_Manager__c +'\'';
            flag = true;
           }
           if(ctrcategorySpecialist )
           {
               soql+= ' AND Category_Specialist__c =\''+user.category_Manager__c +'\'';
              flag = true;
           }
           if(ctrCategoryTechnician )
           {
              soql+= ' AND Technician__c =\''+user.category_Manager__c +'\'';
              flag = true;
           }
           if(ctrcategoryManager)
           {
             soql+= ' AND category_Manager__c =\''+user.category_Manager__c +'\' '; 
             flag = true;
           }
           if(ctrBusinessAnalyst)
           {
             soql+= ' AND Business_Analyst__c =\''+user.category_Manager__c +'\'';
             flag = true;
           }
           if(ctrGSO)
           {
             soql+= ' AND GSO__c =\''+user.category_Manager__c +'\'';
             flag = true;
           }
           
           if(!flag) {
               System.debug(' SCM '+scmmanager + ' CM '+categoryManager);
                 soql+= ' AND ( category_Manager__c =\''+user.category_Manager__c+'\' OR ' +
                        ' GSO__c =\''+user.category_Manager__c +'\' OR '+ 
                        ' SCM_Manager__c =\''+user.category_Manager__c +'\' OR '+ ' Technician__c =\''+user.category_Manager__c +'\' OR '+  ' Business_Analyst__c =\''+user.category_Manager__c +'\' OR'+  ' Category_Specialist__c = \''+user.category_Manager__c +'\' '+')';  
             
            }
        }
        if( user.Category__c != null ){
            soql+= ' AND Category__c = \'' + user.Category__c + '\'';
        }
        if( taxonomy.Sub_Category__c != null ){
            soql+= ' AND Sub_Category__c = \'' + taxonomy.Sub_Category__c + '\'';
        }

             
             //System.assert(false,soql);
             System.debug('*****************'+soql);
             System.debug('*****************'+ctrscmManager);
             System.debug('*****************'+ctrCategorySpecialist);
            
           List<PREP_Initiative__c> initList = (List<PREP_Initiative__c>) database.query(soql); 
           String  sql='SELECT Id,RecordTypeId,Name,Owner.Name,Initiative_Name__c ,Discipline__r.Name ,Category_Manager__r.Name,Status__c ,Project_Lead__R.Name,Technician__r.Name,Commercial_Representative__r.Name,Procurement_Representative__r.Name,Category_Specialist__r.Name,SCM_Manager__r.Name,GSO__r.Name,Business_Analyst__r.Name FROM PREP_Initiative__c where RecordTypeId= \''+ ProInitiative +'\'';
           
           flag = false;
        if( user.category_Manager__c != null )
        {
            if(inOwner)
           {
              sql+= ' AND OwnerId =\''+user.category_Manager__c +'\'';
              flag = true;
           }
          if(ctrSCMManager)
           {
            sql+= ' AND SCM_Manager__c =\''+user.category_Manager__c +'\'';
            flag = true;
           }
           if(ctrCommercialRepresentative )
           {
             sql+= ' AND Commercial_Representative__c =\''+user.category_Manager__c +'\'';
             flag = true;
           }
            if(ctrProcurementRepresentative)
           {
             sql+= ' AND Procurement_Representative__c =\''+user.category_Manager__c +'\' '; 
             flag = true;
           }
            if(ctrBusinessAnalyst )
           {
             sql+= ' AND Business_Analyst__c =\''+user.category_Manager__c +'\'';
             flag = true;
           }
           System.debug('ctrProjectLead'+ctrProjectLead); 
           if(ctrProjectLead && con != null )
           {
             sql+= ' AND Project_Lead__c =\''+ con.Id +'\'';
             flag = true;
           }
           if(!flag ){
              sql+= ' AND ( SCM_Manager__c =\''+user.category_Manager__c +'\' OR '+' OwnerId =\''+user.category_Manager__c +'\' OR '+ ' Commercial_Representative__c =\''+user.category_Manager__c +'\' OR ' + ' Procurement_Representative__c =\''+user.category_Manager__c +'\' OR ' + ' Business_Analyst__c =\''+user.category_Manager__c +'\' ';  
               
               if( con != null )
                   sql += 'OR Project_Lead__c =\'' + con.Id + '\'';
                   
               sql += ')';
           }
        }
        if( user.Category__c != null ){
            sql+= ' AND Category__c =\'' + user.Category__c + '\'';
        }
        if( taxonomy.Sub_Category__c != null ){
            sql+= ' AND Sub_Category__c =\'' + taxonomy.Sub_Category__c + '\'';
        }
             
             System.debug('@@@@@@@@@'+sql);
             System.debug('*****************'+sql);
             System.debug('11111'+ctrProjectLead);
             System.debug('*****************'+ctrCategorySpecialist);
            
           List<PREP_Initiative__c> prjinitList = (List<PREP_Initiative__c>) database.query(sql);
           System.debug('$$$'+prjinitList);
             
           flag = false;      
         String  str='SELECT Id,Name,Owner.Name,Material_Service_Group_Name__c,Category__c,Discipline__c,SAP_Short_Text_Name__c ,Type__c,Includes__c,Category_Manager__r.Name,Category_Specialist__r.Name,Sub_Category__r.Name FROM PREP_Material_Service_Group__c';
         
       if( user.category_Manager__c != null )
       { 
          if(inOwner )
           {
              str+= ' Where OwnerId =\''+user.category_Manager__c +'\'';
              flag = true;
           }
            if(ctrcategoryManager)
           {
             if( flag )
                 str+= ' AND Category_Manager__c =\''+user.category_Manager__c +'\'';
              else
                  str+= ' where Category_Manager__c =\''+user.category_Manager__c +'\'';
               flag = true;
           }
           
             if(ctrcategorySpecialist )
            
           {
               if( flag )
                 str+= ' AND Category_Specialist__c =\''+user.category_Manager__c +'\'';
               else
                   str+= ' Where Category_Specialist__c =\''+user.category_Manager__c +'\'';
             flag = true;
           }  
           
           if(!flag)
           {
               str+=  ' Where ( Category_Specialist__c =\''+user.category_Manager__c +'\' OR ' + ' OwnerId =\''+user.category_Manager__c +'\' OR ' + ' Category_Manager__c =\''+user.category_Manager__c +'\' )';
               flag = true;
           }
       }
       if( user.Category__c != null ){
           if( !flag )
               str+= ' where Sub_Category__r.Category__c =\'' + user.Category__c + '\'';
           else
               str += ' AND Sub_Category__r.Category__c =\'' + user.Category__c + '\'';
           flag = true;
       }
       if( taxonomy.Sub_Category__c != null ){
           if( !flag )
               str+= ' where Sub_Category__c =\'' + taxonomy.Sub_Category__c + '\'';
           else
               str += ' AND Sub_Category__c =\'' + taxonomy.Sub_Category__c + '\'';
           flag = true;
       }
       if( taxonomy.Material_Service_Group_Name__c != null && taxonomy.Material_Service_Group_Name__c != '' ){
           if( !flag )
               str+= ' where Material_Service_Group_Name__c LIKE \'%' + String.escapeSingleQuotes( taxonomy.Material_Service_Group_Name__c ) + '%\'';
           else
                str += ' AND Material_Service_Group_Name__c LIKE \'%' + String.escapeSingleQuotes( taxonomy.Material_Service_Group_Name__c ) + '%\'';
           flag = true;
       }
       system.debug( '***********' + str );
           List<PREP_Material_Service_Group__c> taxonomyList = (List<PREP_Material_Service_Group__c>) database.query(str);
        
        prepInitiativeWrapperList = new List<PREPInitiativeWrapper>(); 
        prepprjInitiativeWrapperList = new List<PREPprjInitiativeWrapper>();
        prepTaxonomyWrapperList = new List<PREPTaxonomyWrapper>();
        
        for(PREP_Initiative__c i : initList){
            prepInitiativeWrapperList.add(new PREPInitiativeWrapper(i));
        }  
        
        for(PREP_Initiative__c p : prjinitList){
            prepprjInitiativeWrapperList.add(new PREPprjInitiativeWrapper(p));
        }  
        
        
        for(PREP_Material_Service_Group__c t : taxonomyList){
            prepTaxonomyWrapperList.add(new PREPTaxonomyWrapper(t));
        }  
//System.assert(false, prepprjInitiativeWrapperList);
        
        prepWrapper = new PREPWrapper(prepInitiativeWrapperList,prepTaxonomyWrapperList,prepprjInitiativeWrapperList); 
               
    }
    
    public PageReference saveAndSubmit(){
        System.debug('saveAndSubmit called');
        
        List<PREPInitiativeWrapper> iniWrapper = new List<PREPInitiativeWrapper>();
        List<PREPprjInitiativeWrapper> prjiniWrapper = new List<PREPprjInitiativeWrapper>();
        List<PREPTaxonomyWrapper> taxWrapper = new List<PREPTaxonomyWrapper>();
        
        for(PREPInitiativeWrapper w : prepWrapper.initWrapperList){
            if(w.selected){ 
                iniWrapper.add(w);
            }
        }
        
        for(PREPprjInitiativeWrapper w : prepWrapper.prjinitWrapperList){
            if(w.selected){ 
                prjiniWrapper.add(w);
            }
        }
        
        for(PREPTaxonomyWrapper w : prepWrapper.taxonomyWrapperList){
            if(w.selected){ 
                taxWrapper.add(w);
            }        
        }
        
        User u = [SELECT Id, Email, Name FROM User WHERE Id = :user.Category_Specialist__c];
       Contact c = null;
       if( u != null && u.Email != null && u.Email != '' )
        {
            List<Contact> contacts = [ Select Id, Name from Contact where Email =: u.Email ];
            
            if( contacts.size() > 0 )
                c = contacts[0];
        }
        
        //System.assert(false,iniWrapper);
        if(iniWrapper.size() > 0){
            Id iniId = submitInitiativesChangeOwner(iniWrapper,u,c);
            
            Approval.ProcessSubmitRequest request = new Approval.ProcessSubmitRequest();
            request.setObjectId(iniId);
            request.setProcessDefinitionNameOrId( 'PREP_Taxonomy_Change_Approval' );
            if(!test.isRunningTest()){
            Approval.ProcessResult result = Approval.process(request); 
             }         
        }
        
        if(prjiniWrapper.size() > 0){
            Id prjId = submitprjinitiativesChangeOwner(prjiniWrapper,u,c);
            
            Approval.ProcessSubmitRequest request = new Approval.ProcessSubmitRequest();
            request.setObjectId(prjId);
            request.setProcessDefinitionNameOrId( 'PREP_Taxonomy_Change_Approval' );
            
            Approval.ProcessResult result = Approval.process(request);            
        }
        
        if(taxWrapper.size() > 0){
            Id taxId = SubmitTaxonomyChangeOwner(taxWrapper,u,null);
            
            Approval.ProcessSubmitRequest request = new Approval.ProcessSubmitRequest();
            request.setObjectId(taxId);
            request.setProcessDefinitionNameOrId( 'PREP_Taxonomy_Change_Approval' );
            
            Approval.ProcessResult result = Approval.process(request);             
        }        
        
        PageReference rageRef = Page.Taxonomy_Requests;
        rageRef.setRedirect(true);
        
        return rageRef;    
    }
    
    public PageReference saveTaxonomyAndInitiatives(){
   // System.assert(false, prepWrapper.initWrapperList);
        System.debug('saveTaxonomyAndInitiatives called');
        List<PREPInitiativeWrapper> iniWrapper = new List<PREPInitiativeWrapper>();
        List<PREPprjInitiativeWrapper> prjiniWrapper = new List<PREPprjInitiativeWrapper>();
        List<PREPTaxonomyWrapper> taxWrapper = new List<PREPTaxonomyWrapper>();
        
        for(PREPInitiativeWrapper w : prepWrapper.initWrapperList){
            if(w.selected){ 
                iniWrapper.add(w);
            }
        }
        for(PREPprjInitiativeWrapper w : prepWrapper.prjinitWrapperList){
            if(w.selected){ 
                prjiniWrapper.add(w);
            }
        }
        
        for(PREPTaxonomyWrapper w : prepWrapper.taxonomyWrapperList){
            if(w.selected){ 
                taxWrapper.add(w);
            }        
        }
        
       User u = null;
       Contact c = null;
       if(user.Category_Specialist__c!= Null )
       {
           u = [SELECT Id, Email, Name FROM User WHERE Id = :user.Category_Specialist__c];
           
           if( u != null && u.Email != null && u.Email != '' )
            {
                List<Contact> contacts = [ Select Id, Name from Contact where Email =: u.Email ];
                
                if( contacts.size() > 0 )
                    c = contacts[0];
            }
       }
        
        if(iniWrapper.size() > 0){
            saveInitiativesChangeOwner(iniWrapper,u,c);
        }
        
        if(prjiniWrapper.size() > 0){
            saveprjInitiativesChangeOwner(prjiniWrapper,u,c);
        }
        
        if(taxWrapper.size() > 0){
            saveTaxonomyChangeOwner(taxWrapper,u,c);
        }
        
        
        PageReference rageRef = Page.Taxonomy_Requests;
        rageRef.setRedirect(true);
        
        return rageRef;
        
    }
    private Id saveInitiativesChangeOwner(List<PREPInitiativeWrapper> iniWrapper, User u, Contact c){
        PREP_Change_Header__c header = new PREP_Change_Header__c();
        List<PREP_Change_Detail__c> detail = new List<PREP_Change_Detail__c>();
        
        //Create a header record for the taxonomy / initiative chnages
        header.Reason__c = 'Initiatives Change';
        header.Change_Type__c = 'Change Owner';
        header.Request_Created_Date__c=System.today();
        header.Request_Last_Updated_Date__c=System.today();
        header.Request_Title__c= RequestTitle;
        header.Request_Status__c = 'New';
        header.Approval_Status__c = 'New';
        header.Change_Status__c = 'New';
        header.Object_Name__c = 'PREP_Initiative__c';
        
        //insert data to the database
        insert header;
        //System.Assert(false,iniWrapper.detail);
        //Create detail records
        for(PREPInitiativeWrapper w : iniWrapper){
        
        //System.Assert(false,CategoryManager );
         
       System.debug('ffff'+CategoryManager );
      //System.Assert(false, '::::::::'+SCMManager);
       if( ownerFlag1 ){
                detail.add(populateDetails(header,'Owner',w.initiative.OwnerId,w.initiative.OwnerId,
                    w.initiative.Id, w.initiative.Name, u, null));
                    }
        /*if(Owner){
                detail.add(populateDetails(header,'Owner',w.initiative.OwnerId,w.initiative.OwnerId,
                    w.initiative.Id, w.initiative.Name, u,null));
            }*/ 
            if(CategoryManager){
                detail.add(populateDetails(header,'CategoryManager',w.initiative.Category_Manager__r.Name,w.initiative.Category_Manager__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
            if(CategoryTechnician){
                detail.add(populateDetails(header,'CategoryTechnician',w.initiative.Technician__r.Name,w.initiative.Technician__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
            if(BusinessAnalyst){
                detail.add(populateDetails(header,'BusinessAnalyst',w.initiative.Business_Analyst__r.Name,w.initiative.Business_Analyst__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            }                   
            if(categorySpecialist){
                detail.add(populateDetails(header,'CategorySpecialist',w.initiative.Category_Specialist__r.Name,w.initiative.Category_Specialist__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
            if(SCMManager){
                detail.add(populateDetails(header,'SCMManager',w.initiative.SCM_Manager__r.Name,w.initiative.SCM_Manager__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            }                 
            if(GSO){
                detail.add(populateDetails(header,'GSO',w.initiative.GSO__r.Name,w.initiative.GSO__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
        }
                
        insert detail;  
        
        return header.id;  
        
    }
    
    private Id submitInitiativesChangeOwner(List<PREPInitiativeWrapper> iniWrapper, User u, Contact c){
        PREP_Change_Header__c header = new PREP_Change_Header__c();
        List<PREP_Change_Detail__c> detail = new List<PREP_Change_Detail__c>();
        
        //Create a header record for the taxonomy / initiative chnages
        header.Reason__c = 'Initiatives Change';
        header.Change_Type__c = 'Change Owner';
        header.Request_Created_Date__c=System.today();
        header.Request_Last_Updated_Date__c=System.today();
        header.Request_Title__c= RequestTitle;
        header.Request_Status__c = 'New';
        header.Approval_Status__c = 'New';
        header.Change_Status__c = 'Submitted';
        header.Object_Name__c = 'PREP_Initiative__c';
        
        //insert data to the database
        insert header;
        //System.Assert(false,iniWrapper.detail);
        //Create detail records
        for(PREPInitiativeWrapper w : iniWrapper){
        
        //System.Assert(false,CategoryManager );
         
       System.debug('ffff'+CategoryManager );
      // System.Assert(false, '::::::::'+ownerFlag1);
       if( ownerFlag1 ){
                detail.add(populateDetails(header,'Owner',w.initiative.OwnerId,w.initiative.OwnerId,
                    w.initiative.Id, w.initiative.Name, u, null));
                    }
        /*if(Owner){
                detail.add(populateDetails(header,'Owner',w.initiative.OwnerId,w.initiative.OwnerId,
                    w.initiative.Id, w.initiative.Name, u,null));
            }*/ 
            if(CategoryManager){
                detail.add(populateDetails(header,'CategoryManager',w.initiative.Category_Manager__r.Name,w.initiative.Category_Manager__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
            if(CategoryTechnician){
                detail.add(populateDetails(header,'CategoryTechnician',w.initiative.Technician__r.Name,w.initiative.Technician__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
            if(BusinessAnalyst){
                detail.add(populateDetails(header,'BusinessAnalyst',w.initiative.Business_Analyst__r.Name,w.initiative.Business_Analyst__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            }                   
            if(categorySpecialist){
                detail.add(populateDetails(header,'CategorySpecialist',w.initiative.Category_Specialist__r.Name,w.initiative.Category_Specialist__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
            if(SCMManager){
                detail.add(populateDetails(header,'SCMManager',w.initiative.SCM_Manager__r.Name,w.initiative.SCM_Manager__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            }                 
            if(GSO){
                detail.add(populateDetails(header,'GSO',w.initiative.GSO__r.Name,w.initiative.GSO__c,
                    w.initiative.Id, w.initiative.Name, u,null));
            } 
        }
                
        insert detail;  
        
        return header.id;  
        
    }
    
    private Id saveprjinitiativesChangeOwner(List<PREPprjinitiativeWrapper> prjiniWrapper, User u, Contact c){
        PREP_Change_Header__c header = new PREP_Change_Header__c();
        List<PREP_Change_Detail__c> detail = new List<PREP_Change_Detail__c>();
        
        //Create a header record for the taxonomy / prjinitiative chnages
        header.Reason__c = 'prjinitiatives Change';
        header.Change_Type__c = 'Change Owner';
        header.Request_Created_Date__c=System.today();
        header.Request_Last_Updated_Date__c=System.today();
        header.Request_Title__c= RequestTitle;
        header.Approval_Status__c = 'New';
        header.Change_Status__c = 'New';
        header.Request_Status__c = 'New';
        header.Object_Name__c = 'PREP_prjinitiative__c';
         //System.Assert(false,header);
        //insert data to the database
        insert header;
        //System.Assert(false, '::::::::'+scmManager1);
        //Create detail records
        for(PREPprjinitiativeWrapper w : prjiniWrapper){
        
            if( ownerFlag ){
                detail.add(populateDetails(header,'Owner',w.prjinitiative.OwnerId,w.prjinitiative.OwnerId,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            } 
        
            if(ProcurementRepresentative){
                detail.add(populateDetails(header,'ProcurementRepresentative',w.prjinitiative.Procurement_Representative__r.Name,w.prjinitiative.Procurement_Representative__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            }                   
            if(CommercialRepresentative ){
                detail.add(populateDetails(header,'CommercialRepresentative',w.prjinitiative.Commercial_Representative__r.Name,w.prjinitiative.Commercial_Representative__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            } 
            System.debug(scmManager1);                
            if(scmManager1){
                detail.add(populateDetails(header,'SCMManager',w.prjinitiative.SCM_Manager__r.Name,w.prjinitiative.SCM_Manager__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            } 
             if(prjBusinessAnalyst ){
                detail.add(populateDetails(header,'BusinessAnalyst',w.prjinitiative.Business_Analyst__r.Name,w.prjinitiative.Business_Analyst__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            }
            if(ProjectLead ){
                detail.add(populateDetails(header,'ProjectLead',w.prjinitiative.Project_Lead__r.Name,w.prjinitiative.Project_Lead__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, null,c));
            }  
        }
                
        insert detail;  
        
        return header.id;  
        
    }
    private Id submitprjinitiativesChangeOwner(List<PREPprjinitiativeWrapper> prjiniWrapper, User u, Contact c){
        PREP_Change_Header__c header = new PREP_Change_Header__c();
        List<PREP_Change_Detail__c> detail = new List<PREP_Change_Detail__c>();
        
        //Create a header record for the taxonomy / prjinitiative chnages
        header.Reason__c = 'prjinitiatives Change';
        header.Change_Type__c = 'Change Owner';
        header.Request_Created_Date__c=System.today();
        header.Request_Last_Updated_Date__c=System.today();
        header.Request_Title__c= RequestTitle;
        header.Approval_Status__c = 'New';
        header.Change_Status__c = 'Submitted';
        header.Request_Status__c = 'New';
        header.Object_Name__c = 'PREP_prjinitiative__c';
         //System.Assert(false,header);
        //insert data to the database
        insert header;
        
        //Create detail records
        for(PREPprjinitiativeWrapper w : prjiniWrapper){
        
            if( ownerFlag ){
                detail.add(populateDetails(header,'Owner',w.prjinitiative.OwnerId,w.prjinitiative.OwnerId,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            } 
        
            if(ProcurementRepresentative){
                detail.add(populateDetails(header,'ProcurementRepresentative',w.prjinitiative.Procurement_Representative__r.Name,w.prjinitiative.Procurement_Representative__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            }                   
            if(CommercialRepresentative ){
                detail.add(populateDetails(header,'CommercialRepresentative',w.prjinitiative.Commercial_Representative__r.Name,w.prjinitiative.Commercial_Representative__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            } 
            System.debug(scmManager1);                
            if(SCMManager ){
                detail.add(populateDetails(header,'SCMManager',w.prjinitiative.SCM_Manager__r.Name,w.prjinitiative.SCM_Manager__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            } 
             if(prjBusinessAnalyst ){
                detail.add(populateDetails(header,'BusinessAnalyst',w.prjinitiative.Business_Analyst__r.Name,w.prjinitiative.Business_Analyst__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, u,null));
            }
            if(ProjectLead ){
                detail.add(populateDetails(header,'ProjectLead',w.prjinitiative.Project_Lead__r.Name,w.prjinitiative.Project_Lead__c,
                    w.prjinitiative.Id, w.prjinitiative.Name, null,c));
            }  
        }
                
        insert detail;  
        
        return header.id;  
        
    }
    
    private id saveTaxonomyChangeOwner(List<PREPTaxonomyWrapper> taxWrapper, User u,Contact c){
        PREP_Change_Header__c header = new PREP_Change_Header__c();
        List<PREP_Change_Detail__c> detail = new List<PREP_Change_Detail__c>();
        
        //Create a header record for the taxonomy / initiative chnages
        header.Reason__c = 'Taxonomy Change';
        header.Change_Type__c = 'Change Owner';
        header.Request_Created_Date__c=System.today();
        header.Request_Last_Updated_Date__c=System.today();
        header.Request_Title__c= RequestTitle;
        header.Request_Status__c = 'New';
        header.Approval_Status__c = 'New';
        
        header.Change_Status__c = 'New';
        header.Object_Name__c = 'PREP_Material_Service_Group__c';   
        
        insert header; 
        
        for(PREPTaxonomyWrapper w : taxWrapper){
             if(t_Owner){
                detail.add(populateDetails(header,'Owner',w.taxonomy.OwnerId,w.taxonomy.OwnerId,
                    w.taxonomy.Id, w.taxonomy.Name, u,null));
            }
            if(t_categoryManager){
                detail.add(populateDetails(header,'categoryManager',w.taxonomy.Category_Manager__r.Name,w.taxonomy.Category_Manager__c,
                    w.taxonomy.Id, w.taxonomy.Name, u,null));
            }                   
            if(t_categorySpecialist){
                detail.add(populateDetails(header,'categorySpecialist',w.taxonomy.Category_Specialist__r.Name,w.taxonomy.Category_Specialist__c,
                    w.taxonomy.Id, w.taxonomy.Name, u,null));
            }                 
        }   
        
        insert detail;  
        
        return header.id;                 
    }
      private id SubmitTaxonomyChangeOwner(List<PREPTaxonomyWrapper> taxWrapper, User u,Contact c){
        PREP_Change_Header__c header = new PREP_Change_Header__c();
        List<PREP_Change_Detail__c> detail = new List<PREP_Change_Detail__c>();
         //System.Assert(false,header);
        //Create a header record for the taxonomy / initiative chnages
        header.Reason__c = 'Taxonomy Change';
        header.Change_Type__c = 'Change Owner';
        header.Request_Created_Date__c=System.today();
        header.Request_Last_Updated_Date__c=System.today();
        header.Request_Title__c= RequestTitle;
        header.Request_Status__c = 'New';
        header.Approval_Status__c = 'New';
        
        header.Change_Status__c = 'Submitted';
        header.Object_Name__c = 'PREP_Material_Service_Group__c';   
       
        insert header; 
        
        
        for(PREPTaxonomyWrapper w : taxWrapper){
             if(t_Owner){
                detail.add(populateDetails(header,'Owner',w.taxonomy.OwnerId,w.taxonomy.OwnerId,
                    w.taxonomy.Id, w.taxonomy.Name, u,null));
            }
            if(t_categoryManager){
                detail.add(populateDetails(header,'categoryManager',w.taxonomy.Category_Manager__r.Name,w.taxonomy.Category_Manager__c,
                    w.taxonomy.Id, w.taxonomy.Name, u,null));
            }                   
            if(t_categorySpecialist){
                detail.add(populateDetails(header,'categorySpecialist',w.taxonomy.Category_Specialist__r.Name,w.taxonomy.Category_Specialist__c,
                    w.taxonomy.Id, w.taxonomy.Name, u,null));
            }                 
        }   
        
        insert detail;  
        
        return header.id;                 
    }
    
    private PREP_Change_Detail__c populateDetails(PREP_Change_Header__c header, String fieldName, String fromValue, String fromRecId,
            String recordId, String recordName,User u, Contact c){

        PREP_Change_Detail__c d = new PREP_Change_Detail__c();
        d.PREP_Change_Header__c = header.id;
        d.Field_Name__c = fieldName;
        d.From_Field_value__c = fromValue;
        d.Record_Id__c = fromRecId;
        if(u!= null){  
        d.To_Field_value__c = u.Name;  
        }
        else{
        d.To_Field_value__c = c.Name;
        }
        if(user.Category_Specialist__c!= null){
        d.To_Field_Id__c = user.Category_Specialist__c; 
        }
        else{
        
        d.To_Field_Id__c =  user.Project_Lead__C;
        }     
        d.From_Field_Id__c = fromRecId;  
        d.Update_Record_Id__c = recordId;
        d.Update_Record_Name__c = recordName;
            
        return d;
    }
    
    /*wrapper class for the PREP taxonony / initiatives */
    public class PREPWrapper{
        public boolean selected {get;set;}               
        public String reason {get;set;}
        
        public PREP_Initiative__c initiative {get;set;}
        public PREP_Initiative__c prjinitiative {get;set;}
        public PREP_Material_Service_Group__c taxonomy {get;set;}
        
        public List<PREPInitiativeWrapper> initWrapperList {get;set;}
        public List<PREPprjInitiativeWrapper> prjinitWrapperList {get;set;}
        public List<PREPTaxonomyWrapper> taxonomyWrapperList {get;set;}
        
        
        public PREPWrapper(PREP_Initiative__c initiative,PREP_Initiative__c prjinitiative){
            this.initiative = initiative;
            this.prjinitiative = prjinitiative;
       }
        
        /*public PREPWrapper(PREP_Initiative__c prjinitiative){
            
        }*/
        
        public PREPWrapper(PREP_Material_Service_Group__c taxonomy){
            this.taxonomy = taxonomy;
        } 
        
        public PREPWrapper(){
        
        }
        
        public PREPWrapper(List<PREPInitiativeWrapper> initWrapperList, List<PREPTaxonomyWrapper> taxonomyWrapperList,List<PREPprjInitiativeWrapper> prjinitWrapperList){
            this.initWrapperList = initWrapperList;
            this.prjinitWrapperList = prjinitWrapperList;
            this.taxonomyWrapperList = taxonomyWrapperList;
        }         
             
    }
    
    public class PREPInitiativeWrapper{
        public boolean selected {get;set;}
        
        public PREP_Initiative__c initiative {get;set;}
        
        public PREPInitiativeWrapper(PREP_Initiative__c initiative){
            this.initiative = initiative;
        }
             
    }
    public class PREPprjInitiativeWrapper{
        public boolean selected {get;set;}
        
        public PREP_Initiative__c prjinitiative {get;set;}
        
        public PREPprjInitiativeWrapper(PREP_Initiative__c prjinitiative){
            this.prjinitiative = prjinitiative;
        }
             
    }
    
    public class PREPTaxonomyWrapper{
        public boolean selected {get;set;}               

        public PREP_Material_Service_Group__c taxonomy {get;set;}
        
        public PREPTaxonomyWrapper(PREP_Material_Service_Group__c taxonomy){
            this.taxonomy = taxonomy;
        }        
    }
}